%This file performs the initialization for the MAP estimation
function theta0 = init(data, K)
D = mvnfactory(size(data,1));
D2 = mixturefactory(D, K);
LL_save = -inf;

penalizer_theta = D2.penalizerparam(data);
[L, C] = kmeanspp(data, K);
for iter = 1:30
    % convert k-means output to mixture params
    theta0.p = zeros(K,1);
    for k = 1:K
        theta0.D{k}.mu = C(:,k);
        X = data(:,L==k);
        X = X - repmat(C(:,k), [1,size(X,2)]);
        theta0.D{k}.sigma = X * X.' / size(X,2);
        theta0.p(k) = sum(L==k) / length(L);
    end
    %ones(K,1) / K;
    LL = D2.ll(theta0, data);
    %LL = LL + D2.penalizercost(theta0, penalizer_theta);
    if LL > LL_save
        theta0Save = theta0;
    end
end
theta0 = theta0Save;